package calcolonumerico.analisi;

public class Integrale {

    public static double rettInf(double a, double b, int n, Funzione f) {
        double intervallo = b - a;
        double somma = 0.0;
        for (int i = 0; i < n; i++) {
            double x = a + intervallo * i / n;
            somma += f.val(x);
        }
        return somma * intervallo / n;
    }

    public static double rettSup(double a, double b, int n, Funzione f) {
        double intervallo = b - a;
        double somma = 0.0;
        for (int i = 1; i <= n; i++) {
            double x = a + intervallo * i / n;
            somma += f.val(x);
        }
        return somma * intervallo / n;
    }

    public static double trap(double a, double b, int n, Funzione f) {
        double intervallo = b - a;
        double somma = (f.val(a) + f.val(b)) / 2.0;
        for (int i = 1; i < n; i++) {
            double x = a + intervallo * i / n;
            somma += f.val(x);
        }
        return somma * intervallo / n;
    }

    public static double simp(double a, double b, int n, Funzione f) {
        double intervallo = b - a;
        n *= 2;
        double somma1 = 0.0;
        double somma2 = 0.0;
        for (int i = 1; i < n; i++) {
            double x = a + intervallo * i / n;
            if (i % 2 == 1)
                somma1 += f.val(x);
            else
                somma2 += f.val(x);
        }
        return (f.val(a) + f.val(b) + somma1 * 4.0 + somma2 * 2.0) * intervallo / (n * 3.0);
    }

}
